CHUNKY_SPRITE    equ       $10

                                      ; $14 = round
                                      ; $18 = scanlines
                                      ; $1c = raster
                                      ; $20 = scanlines 2
                                      ; $24 = jig
                                      ; $28 = raster2


;*************************************************
; CHUNKY_UPDATE (call this everyframe AFTER wait_vblank)
;*************************************************

CHUNKY_UPDATE:

          cmp.b    #0,CHUNKY_FLAG
          beq      .CHUNKY_UPDATE_TOP

          lea       PALETTES+16*2*130+2,a0        ; copy lower half
          lea       CHUNKY_BUFFER+125*2*15,a1
          move.b   #0,CHUNKY_FLAG

          jmp       .CHUNKY_UPDATE_DOIT

.CHUNKY_UPDATE_TOP:

          lea       PALETTES+16*2*5+2,a0          ; copy upper half
          lea       CHUNKY_BUFFER,a1
          move.b     #1,CHUNKY_FLAG

.CHUNKY_UPDATE_DOIT

          rept      5*25                          ; unrolled!
          move.l    (a1)+,(a0)+
          move.l    (a1)+,(a0)+
          move.l    (a1)+,(a0)+
          move.l    (a1)+,(a0)+
          move.l    (a1)+,(a0)+
          move.l    (a1)+,(a0)+
          move.l    (a1)+,(a0)+
          move.w    (a1)+,(a0)+
          add.l     #2,a0
          endr

          rts

;*************************************************
; CHUNKY_INIT (call this once at startup)
;*************************************************

          ; set tiles & palettes

CHUNKY_INIT:

          move.w    #$1,VRAM_MOD                  ; inc 1
          move.w    #SCB1+CHUNKY_SPRITE*$40,d0    ; startsprite
          move.w    d0,d1                         ; save startsprite
          move.w    #$0500,d2                     ; startpalette
          move.w    CHUNKY_EFFECT,d3


          move.w    #25-1,d6
.rgb_sprite_loop2
          move.w    #10-1,d7
.rgb_sprite_loop1

          move.w    CHUNKY_EFFECT,d3

          move.w    d1,VRAM_ADDR                  ; write addres
          move.w    d3,VRAM_RW        ; 1st tile
          move.w    d2,VRAM_RW                    ; palette

          add.w     #$40,d1                       ; next spritestrip
          add.w     #1,d3

          move.w    d1,VRAM_ADDR                  ; write addres
          move.w    d3,VRAM_RW      ; 2nd tile
          move.w    d2,VRAM_RW                    ; palette

          add.w     #$40,d1                       ; next spritestrip
          add.w     #1,d3

          move.w    d1,VRAM_ADDR                  ; write addres
          move.w    d3,VRAM_RW      ; 3rd tile
          move.w    d2,VRAM_RW                    ; palette

          add.w     #$40,d1                       ; next spritestrip
          add.w     #1,d3

          move.w    d1,VRAM_ADDR                  ; write addres
          move.w    d3,VRAM_RW      ; 4th tile
          move.w    d2,VRAM_RW                    ; palette

          add.w     #$40,d1                       ; next spritestrip

          add.w     #$0100,d2                     ; next palette

          dbra      d7,.rgb_sprite_loop1

          add.w     #2,d0
          move.w    d0,d1

          dbra      d6,.rgb_sprite_loop2


          ;***************************************
          ; set Shrinks

          move.w    #SCB2+CHUNKY_SPRITE,VRAM_ADDR

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW

          move.w    #SCB2+CHUNKY_SPRITE+20,VRAM_ADDR

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW

          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0f7f,VRAM_RW
          move.w    #$0c7f,VRAM_RW


          ;***************************************
          ; set y-pos

          move.w    #SCB3+CHUNKY_SPRITE,VRAM_ADDR
          move.w    #496,d3		          ; very strange: 496 is top of the screen and -26 is offset to map an screen
          sub.w     #12,d3
          lsl.w	    #7,d3			  ;
          add.w	    #40,d3			  ; height = 1         <================ windowsize is really strange!
          move.w    d3,VRAM_RW		    	  ; write

          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW

          move.w    #SCB3+CHUNKY_SPRITE+20,VRAM_ADDR
          move.w    #496,d3		          ; very strange: 496 is top of the screen and -26 is offset to map an screen
          sub.w     #12+4,d3
          lsl.w	    #7,d3			  ;
          add.w	    #40,d3			  ; height = 1         <================ windowsize is really strange!
          move.w    d3,VRAM_RW		    	  ; write

          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW
          move.w    #$40,VRAM_RW


          ;***************************************
          ; set x-pos

          move.w    #SCB4+CHUNKY_SPRITE,VRAM_ADDR
          move.w    #8+15*4*0,d3			; is offset to map an screen
          lsl.w	    #7,d3			;
          move.w    d3,VRAM_RW

          move.w    #SCB4+CHUNKY_SPRITE+20,VRAM_ADDR
          move.w    #8+15*4*0,d3			; is offset to map an screen
          lsl.w	    #7,d3			;
          move.w    d3,VRAM_RW

          rts
