
MULTICOLOR:

          ;---------------------------------------
          ; move lights
          ;---------------------------------------

          move.b    BIOS_P1CURRENT,d0

   	  btst	    #4,d0 ; up
	  bne	    .noA

          add.l     #4,SINUS_RED_X
          and.l     #$7fe,SINUS_RED_X
          add.l     #8,SINUS_RED_Y
          and.l     #$7fe,SINUS_RED_Y
.noA
   	  btst	    #5,d0 ; up
	  bne	    .noB

          add.l     #8,SINUS_GREEN_X
          and.l     #$7fe,SINUS_GREEN_X
          add.l     #4,SINUS_GREEN_Y
          and.l     #$7fe,SINUS_GREEN_Y
.noB
   	  btst	    #6,d0 ; up
	  bne	    .noC

          add.l     #12,SINUS_BLUE_X
          and.l     #$7fe,SINUS_BLUE_X
          add.l     #4,SINUS_BLUE_Y
          and.l     #$7fe,SINUS_BLUE_Y
.noC

          ;---------------------------------------
          ; calculate offset in 'red light table'
          ;---------------------------------------

          lea       sinus,a0
          add.l     SINUS_RED_X,a0
          move.l    (a0),d0
          add.l     d0,d0
          sub.l     #14,d0

          lea       sinus,a0
          add.l     SINUS_RED_Y,a0
          move.l    (a0),d1
          add.l     #6,d1
          lsl.l     #8,d1       ;256 = 2x128words

          lea       source_red,a1
          add.l     d0,a1
          add.l     d1,a1

          ;---------------------------------------
          ; calculate offset in 'green light table'
          ;---------------------------------------

          lea       sinus,a0
          add.l     SINUS_GREEN_X,a0
          move.l    (a0),d0
          add.l     d0,d0
          sub.l     #14,d0

          lea       sinus,a0
          add.l     SINUS_GREEN_Y,a0
          move.l    (a0),d1
          add.l     #6,d1
          lsl.l     #8,d1       ;256 = 2x128words

          lea       source_green,a2
          add.l     d0,a2
          add.l     d1,a2

          ;---------------------------------------
          ; calculate offset in 'blue light table'
          ;---------------------------------------

          lea       sinus,a0
          add.l     SINUS_BLUE_X,a0
          move.l    (a0),d0
          add.l     d0,d0
          sub.l     #14,d0

          lea       sinus,a0
          add.l     SINUS_BLUE_Y,a0
          move.l    (a0),d1
          add.l     #6,d1
          lsl.l     #8,d1       ;256 = 2x128words

          lea       source_blue,a3
          add.l     d0,a3
          add.l     d1,a3

          ;---------------------------------------
          ; do it! :)
          ;---------------------------------------

          lea       CHUNKY_BUFFER,a0              ; offset to chunky-buffer

          rept      50

          rept      75
          move.w    (a1)+,d0
          add.w     (a2)+,d0
          add.w     (a3)+,d0
          move.w    d0,(a0)+
          endr

          ; 1 row down (128-75) * 2 (word)
          add.l     #106,a1
          add.l     #106,a2
          add.l     #106,a3

          endr
          rts

          rts

          ;---------------------------------------
          ; data
          ;---------------------------------------

source_red:
          include   "lights\light_red.inc"
source_green:
          include   "lights\light_green.inc"
source_blue:
          include   "lights\light_blue.inc"
          
sinus:

          dc.l	34,34,35,35,35,35,36,36,36,37,37,37,38,38,38,38
          dc.l	39,39,39,40,40,40,40,41,41,41,42,42,42,42,43,43
          dc.l	43,43,44,44,44,45,45,45,45,46,46,46,46,47,47,47
          dc.l	47,48,48,48,48,49,49,49,49,49,50,50,50,50,51,51
          dc.l	51,51,51,52,52,52,52,52,53,53,53,53,53,53,54,54
          dc.l	54,54,54,54,55,55,55,55,55,55,55,56,56,56,56,56
          dc.l	56,56,56,56,57,57,57,57,57,57,57,57,57,57,57,57
          dc.l	58,58,58,58,58,58,58,58,58,58,58,58,58,58,58,58
          dc.l	58,58,58,58,58,58,58,58,58,58,58,58,58,58,58,58
          dc.l	58,57,57,57,57,57,57,57,57,57,57,57,57,56,56,56
          dc.l	56,56,56,56,56,56,55,55,55,55,55,55,55,54,54,54
          dc.l	54,54,54,53,53,53,53,53,53,52,52,52,52,52,51,51
          dc.l	51,51,51,50,50,50,50,49,49,49,49,49,48,48,48,48
          dc.l	47,47,47,47,46,46,46,46,45,45,45,45,44,44,44,43
          dc.l	43,43,43,42,42,42,42,41,41,41,40,40,40,40,39,39
          dc.l	39,38,38,38,38,37,37,37,36,36,36,35,35,35,35,34
          dc.l	34,34,33,33,33,33,32,32,32,31,31,31,30,30,30,30
          dc.l	29,29,29,28,28,28,28,27,27,27,26,26,26,26,25,25
          dc.l	25,25,24,24,24,23,23,23,23,22,22,22,22,21,21,21
          dc.l	21,20,20,20,20,19,19,19,19,19,18,18,18,18,17,17
          dc.l	17,17,17,16,16,16,16,16,15,15,15,15,15,15,14,14
          dc.l	14,14,14,14,13,13,13,13,13,13,13,12,12,12,12,12
          dc.l	12,12,12,12,11,11,11,11,11,11,11,11,11,11,11,11
          dc.l	10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10
          dc.l	10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10
          dc.l	10,11,11,11,11,11,11,11,11,11,11,11,11,12,12,12
          dc.l	12,12,12,12,12,12,13,13,13,13,13,13,13,14,14,14
          dc.l	14,14,14,15,15,15,15,15,15,16,16,16,16,16,17,17
          dc.l	17,17,17,18,18,18,18,19,19,19,19,19,20,20,20,20
          dc.l	21,21,21,21,22,22,22,22,23,23,23,23,24,24,24,25
          dc.l	25,25,25,26,26,26,26,27,27,27,28,28,28,28,29,29
          dc.l	29,30,30,30,30,31,31,31,32,32,32,33,33,33,33,34